<?php

namespace App\Http\Controllers;

use App\Models\ModoVacaciones;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class ModoVacacionesController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = ModoVacaciones::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new ModoVacaciones())->getFillable());
        $modoVacaciones = ModoVacaciones::create($payload);

        return response()->json([
            'success' => true,
            'data' => $modoVacaciones,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(ModoVacaciones $modoVacaciones): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $modoVacaciones,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, ModoVacaciones $modoVacaciones): JsonResponse
    {
        $payload = $request->only((new ModoVacaciones())->getFillable());
        $modoVacaciones->update($payload);

        return response()->json([
            'success' => true,
            'data' => $modoVacaciones,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(ModoVacaciones $modoVacaciones): JsonResponse
    {
        $modoVacaciones->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}